//+------------------------------------------------------------------+
//|                                             ^X_Parabolic_BAR.mq4 |
//|                                                      Version 1.2 |
//|                     Copyright  2007, Mr.WT, Senior Linux Hacker |
//|                                       http://www.metaquotes.net/ |
//|                  Bar created by wibitiens - Forex TSD - May 2007 |
//+------------------------------------------------------------------+

#property copyright "Copyright  2007, Mr.WT, Senior Linux Hacker - Modified by wibitiens"
#property link      "http://www.metaquotes.net/"

#property indicator_chart_window
#property indicator_color1 Aqua
#property indicator_color2 Orange
#property indicator_color3 DeepSkyBlue
#property indicator_color4 Red

extern int _RegressionDegree = 3;
extern color _TrendLineColor = Gold;
extern color _ResLineColor = OrangeRed;
extern color _SupLineColor = DeepSkyBlue;
extern color _RegressionColor1 = Yellow;
extern color _RegressionColor2 = Lime;
extern color _RegressionColor3 = Red;
extern color _RegressionColor4 = RoyalBlue;
//------------------------------------------
double fx,fx1;
double _a[10,10],_b[10],_x[10],sx[20];
double sum,sum1,sq; 
int p,nn,kt;
//---------------------
int i0,ip,pn,i0n,ipn, _j;
int t0,tp,te,te1;
int _N_Time, _Cur_Period;
double _K_L_Dev_min = 1.73;
double _K_N_L_Dev = 2.73;


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init() {
//----
IndicatorShortName("Stop And Reverse");

if(Period() == PERIOD_MN1) {
 p = 13;
} else if(Period() == PERIOD_W1) {
 p = 21;
} else if(Period() == PERIOD_D1) {
 p = 89;
} else if(Period() == PERIOD_H4) {
 p = 144;
} else p = 233;
//--- too small history
if(p>Bars) {
  Comment("\n\n                    ERROR - TOO SMALL HISTORY, RETURN NOW!");
  return(-1); // then exit
}

//----------------------ar------------------------------
  kt=Period()*60;
  nn=_RegressionDegree+1; 
  //----------------------
  t0=Time[0];
  i0=iBarShift(Symbol(),Period(),t0);
  ip=i0+p;
  tp=Time[ip];
  pn=p;

	 ObjectCreate  ("Text1", OBJ_LABEL, 0, 0, 0);
 	 ObjectSet("Text1", OBJPROP_CORNER, 1);
	 ObjectSet("Text1", OBJPROP_XDISTANCE, 10);
	 ObjectSet("Text1", OBJPROP_YDISTANCE, 10);       

	 ObjectCreate  ("Text2", OBJ_LABEL, 0, 0, 0);
 	 ObjectSet("Text2", OBJPROP_CORNER, 1);
	 ObjectSet("Text2", OBJPROP_XDISTANCE, 10);
	 ObjectSet("Text2", OBJPROP_YDISTANCE, 25);       
    
//----
_N_Time = 0;
_Cur_Period = 0;
return(0);
}

int deinit() {

  ObjectDelete("Text1");
  ObjectDelete("Text2");
  ObjectDelete("Text3");
  ObjectDelete("Text4");
  ObjectDelete("UpLevel");
  ObjectDelete("DwLevel");
  ObjectDelete("Level");

  Comment("");
return(0);
}

//+------------------------------------------------------------------+

int start() {

if( _N_Time != Time[0] || _Cur_Period != Period() ) {
//=================================================================
  int i,n,k;
  double std_dev;
  //---- 
    if (i0n!=i0 || ipn!=ip)
    {
      p=ip-i0;
      i0n=ip;
      ipn=ip;      
      pn=p;    
    }
    //======================PR================================================
    sx[1]=p+1;
    //----------------------sx------------------------------------------------
    for(i=1; i<=nn*2-2; i++) 
    {
      sum=0.0; 
      for(n=i0; n<=i0+p; n++) sum+=MathPow(n,i); 
      sx[i+1]=sum;
    }  
    //----------------------syx-----------------------------------------------
    for(i=1; i<=nn; i++) 
    {
      sum=0.0; 
      for(n=i0; n<=i0+p; n++) 
      {
        if (i==1) sum+=Close[n]; 
        else 
        sum+=Close[n]*MathPow(n,i-1);
      } 
      _b[i]=sum;
    } 
    //===============Matrix==================================================
    for(_j=1; _j<=nn; _j++) 
    {
      for(i=1; i<=nn; i++) {k=i+_j-1; _a[i,_j]=sx[k];}
    }  
    //===============Gauss===================================================
    af_Gauss(nn,_a,_b,_x);
    //=======================SQ==============================================
    sq=0.0;
    for (n=p; n>=0; n--)
    {
      sum=0.0;
      for(k=1; k<=_RegressionDegree; k++) {
        sum+=_x[k+1]*MathPow(i0+n,k); 
        sum1+=_x[k+1]*MathPow(i0+n+1,k);
      }
      fx=_x[1]+sum;
      sq+=MathPow(Close[n+i0]-fx,2);
    }
    std_dev = MathSqrt(sq/(p+1));

// regression calculation
int end_bar = 1, start_bar = p + 1, q = p;
//---- calculate price values
   double xvalue,a,b,c,sumy=0.0,sumx=0.0,sumxy=0.0,sumx2=0.0;
   for(int xx=0; xx<q; xx++)
     {
      xvalue=Close[end_bar+xx];
      sumy+=xvalue;
      sumxy+=xvalue*xx;
      sumx+=xx;
      sumx2+=xx*xx;
     }
   c=sumx2*q-sumx*sumx;
   if(c==0.0) return(0);
   b=(sumxy*q-sumx*sumy)/c;
   a=(sumy-sumx*b)/q;
   double LR_price_2=a;
   double LR_price_1=a+b*q;
   double _K1 = MathAbs(LR_price_1-LR_price_2); _K1 /= std_dev; _K1 /= 2;
   if(_K1 < _K_L_Dev_min) {
     sq = _K_L_Dev_min * std_dev;
   } else sq = _K1 * std_dev;
   //---
   sq = _K_L_Dev_min * std_dev;
   sq = _K_N_L_Dev * std_dev;
//=======================================================================

    int     ctx = 0;
    bool    upfirst = true, dwfirst = true;
    int     up_x1=0, up_x2=0, dw_x1=0, dw_x2=0;
    double  up_y1=0, up_y2=0, dw_y1=0, dw_y2=0;
    int     up_strength=0 , down_strength=0;
    int     upx=0, upy=0, dwx=0, dwy=0;
        
    for (n=p; n>=-p/2; n--) 
    {
      sum=0.0; 
      sum1=0.0; 
      for(k=1; k<=_RegressionDegree; k++) {
        sum+=_x[k+1]*MathPow(i0+n,k); 
        sum1+=_x[k+1]*MathPow(i0+n+1,k);
      }  
      fx=_x[1]+sum;
      fx1=_x[1]+sum1;
                      
      if (n<0)
      {
        if ((n+i0)<0) 
        {
          te=Time[0]-(n+i0)*kt; 
          te1=Time[0]-(n+i0+1)*kt;
        } 
        
        if (fx>fx1) {
          if (upfirst==true)
               { upfirst = false; up_x1 = te1; up_y1 = fx1; }
          else                  { up_x2 = te1; up_y2 = fx1; }
          
        }
        if (fx<fx1) {
          if (dwfirst==true)
               { dwfirst = false; dw_x1 = te1; dw_y1 = fx1; }
          else                  { dw_x2 = te1; dw_y2 = fx1; }

        }
      }
    }




    up_x2 = up_x2 - up_x1; up_x1 = 0; up_x2 = up_x2 / 60 / Period();
    dw_x2 = dw_x2 - dw_x1; dw_x1 = 0; dw_x2 = dw_x2 / 60 / Period();

    up_y2 = up_y2 - up_y1; up_y1 = 0; up_y2 = up_y2 * (1/Point);
    dw_y2 = dw_y2 - dw_y1; dw_y1 = 0; dw_y2 = dw_y2 * (1/Point);

    upx = MathAbs(MathRound(up_x2));
    upy = MathAbs(MathRound(up_y2));
    dwx = MathAbs(MathRound(dw_x2));
    dwy = MathAbs(MathRound(dw_y2));

    if (up_x2>0) up_strength   = upy;
    if (dw_x2>0) down_strength = dwy;

	 ObjectSetText ("Text1", "Up Strength = "+ up_strength, 10, "Arial Bold", Lime);
	 ObjectSetText ("Text2", "Down Strength = "+ down_strength, 10, "Arial Bold", Red);

    datetime   t1=Time[1]+ Period()*60*10, t2= t1 + Period()*60*2;
    double     center  = WindowPriceMin(0) + (WindowPriceMax(0)-WindowPriceMin(0))/2;
    double     divider = (WindowPriceMax(0)-center)/1500;

    if (ObjectFind("UpLevel")>-1) ObjectDelete("UpLevel");
    if (ObjectFind("DwLevel")>-1) ObjectDelete("DwLevel");
    if (ObjectFind("Level")  >-1) ObjectDelete("Level");
    
    ObjectCreate("UpLevel",OBJ_RECTANGLE, 0, t1, center, t2, center+(upy*divider));
    ObjectSet("UpLevel", OBJPROP_COLOR, Lime);

    ObjectCreate("DwLevel",OBJ_RECTANGLE, 0, t1, center, t2, center-(dwy*divider));
    ObjectSet("DwLevel", OBJPROP_COLOR, Red);
    
    ObjectCreate("Level",OBJ_RECTANGLE, 0, t1-Period()*60, center+(0.1*Point), 
                                           t2+Period()*60, center-(0.1*Point));
    ObjectSet("Level", OBJPROP_COLOR, Blue);
    WindowRedraw();



    
//=================================================================
_N_Time = Time[0];
_Cur_Period = Period();
}//main if()
return(0);
}//end of program
//+------------------------------------------------------------------+

int af_Gauss(int n, double& a[][],double& b[], double& x[]) {
  int i,j,k,l;
  double q,m,t;

  for(k=1; k<=n-1; k++) 
  {
    l=0; 
    m=0; 
    for(i=k; i<=n; i++) 
    {
      if (MathAbs(a[i,k])>m) {m=MathAbs(a[i,k]); l=i;}
    } 
    if (l==0) return(0);   

    if (l!=k) 
    {
      for(j=1; j<=n; j++) 
      {
        t=a[k,j]; 
        a[k,j]=a[l,j]; 
        a[l,j]=t;
      } 
      t=b[k]; 
      b[k]=b[l]; 
      b[l]=t;
    }  

    for(i=k+1;i<=n;i++) 
    {
      q=a[i,k]/a[k,k]; 
      for(j=1;j<=n;j++) 
      {
        if (j==k) a[i,j]=0; 
        else 
        a[i,j]=a[i,j]-q*a[k,j];
      } 
      b[i]=b[i]-q*b[k];
    }
  }  
  
  x[n]=b[n]/a[n,n]; 
  
  for(i=n-1;i>=1;i--) 
  {
    t=0; 
    for(j=1;j<=n-i;j++) 
    {
      t=t+a[i,i+j]*x[i+j]; 
      x[i]=(1/a[i,i])*(b[i]-t);
    }
  }
}
//===========================================================================

